## libbson 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project (libbson)

option(ENABLE_TESTS "Build libbson tests." ON)

include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckStructHasMember)
include(CheckSymbolExists)
include(TestBigEndian)
include(InstallRequiredSystemLibraries)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/build/cmake)

# Set BSON_MAJOR_VERSION, BSON_MINOR_VERSION, etc.
include(LoadVersion)
LoadVersion(${PROJECT_SOURCE_DIR}/VERSION_CURRENT BSON)
LoadVersion(${PROJECT_SOURCE_DIR}/VERSION_RELEASED BSON_RELEASED)

message("Current version (from VERSION_CURRENT file): ${BSON_VERSION}")
if (NOT ${BSON_VERSION} STREQUAL ${BSON_RELEASED_VERSION})
   message("Previous release (from VERSION_RELEASED file): ${BSON_RELEASED_VERSION}")
endif()

set (SOURCE_DIR "${PROJECT_SOURCE_DIR}/")

set (BSON_API_VERSION 1.0)

set (CPACK_RESOURCE_FILE_LICENSE "${SOURCE_DIR}/COPYING")
set (CPACK_PACKAGE_VERSION_MAJOR ${BSON_MAJOR_VERSION})
set (CPACK_PACKAGE_VERSION_MINOR ${BSON_MINOR_VERSION})

include (CPack)

TEST_BIG_ENDIAN(BSON_BIG_ENDIAN)

# These need proper checks like automake.
set (BSON_PTHREAD_ONCE_INIT_NEEDS_BRACES 0)

#librt needed on linux for clock_gettime
find_library(RT_LIBRARY rt)
if (RT_LIBRARY)
   #set required libraries for CHECK_FUNCTION_EXISTS
   set(CMAKE_REQUIRED_LIBRARIES ${RT_LIBRARY})
endif()

# See https://public.kitware.com/Bug/view.php?id=15659
CHECK_SYMBOL_EXISTS(snprintf stdio.h BSON_HAVE_SNPRINTF)
if (NOT BSON_HAVE_SNPRINTF)
  set(BSON_HAVE_SNPRINTF 0)
else ()
  set(BSON_HAVE_SNPRINTF 1)
endif ()

CHECK_FUNCTION_EXISTS(_set_output_format BSON_NEEDS_SET_OUTPUT_FORMAT)
if (NOT BSON_NEEDS_SET_OUTPUT_FORMAT)
  set(BSON_NEEDS_SET_OUTPUT_FORMAT 0)
endif ()

CHECK_STRUCT_HAS_MEMBER("struct timespec" tv_sec time.h BSON_HAVE_TIMESPEC)
if (NOT BSON_HAVE_TIMESPEC)
  message(STATUS "    no timespec struct")
  set(BSON_HAVE_TIMESPEC 0)
else ()
  message(STATUS "    struct timespec found")
  set(BSON_HAVE_TIMESPEC 1)
endif ()

if (MSVC)
   set (BSON_OS 2)
   set (BSON_HAVE_CLOCK_GETTIME 0)
   set (BSON_HAVE_STDBOOL_H 0)
   set (BSON_HAVE_STRNLEN 0)
   set (BSON_EXTRA_ALIGN 1)
else ()
   find_package (Threads)

   set (BSON_OS 1)
   CHECK_FUNCTION_EXISTS(clock_gettime BSON_HAVE_CLOCK_GETTIME)
   if (NOT BSON_HAVE_CLOCK_GETTIME)
      set(BSON_HAVE_CLOCK_GETTIME 0)
   endif ()
   CHECK_FUNCTION_EXISTS(strnlen BSON_HAVE_STRNLEN)
   if (NOT BSON_HAVE_STRNLEN)
      set(BSON_HAVE_STRNLEN 0)
   endif ()
   CHECK_INCLUDE_FILE(stdbool.h BSON_HAVE_STDBOOL_H)
   if (NOT BSON_HAVE_STDBOOL_H)
      set(BSON_HAVE_STDBOOL_H 0)
   endif ()
   set (BSON_EXTRA_ALIGN 1)
endif ()

set (BSON_HAVE_ATOMIC_32_ADD_AND_FETCH 1)
set (BSON_HAVE_ATOMIC_64_ADD_AND_FETCH 1)

if (BSON_BIG_ENDIAN)
   set (BSON_BYTE_ORDER 4321)
else ()
   set (BSON_BYTE_ORDER 1234)
endif ()

configure_file (
   "${SOURCE_DIR}/src/bson/bson-config.h.in"
   "${PROJECT_BINARY_DIR}/src/bson/bson-config.h"
)

configure_file (
   "${SOURCE_DIR}/src/bson/bson-version.h.in"
   "${PROJECT_BINARY_DIR}/src/bson/bson-version.h"
)

configure_file (
   "${PROJECT_SOURCE_DIR}/build/cmake/bson/bson-stdint.h"
   "${PROJECT_BINARY_DIR}/src/bson/bson-stdint.h"
)

include_directories("${PROJECT_BINARY_DIR}/src/bson")
include_directories("${SOURCE_DIR}/src/bson")
include_directories("${SOURCE_DIR}/src")

if (APPLE)
   cmake_policy(SET CMP0042 OLD)
endif()

set (SOURCES
   ${SOURCE_DIR}/src/bson/bcon.c
   ${SOURCE_DIR}/src/bson/bson.c
   ${SOURCE_DIR}/src/bson/bson-atomic.c
   ${SOURCE_DIR}/src/bson/bson-clock.c
   ${SOURCE_DIR}/src/bson/bson-context.c
   ${SOURCE_DIR}/src/bson/bson-error.c
   ${SOURCE_DIR}/src/bson/bson-iso8601.c
   ${SOURCE_DIR}/src/bson/bson-iter.c
   ${SOURCE_DIR}/src/bson/bson-json.c
   ${SOURCE_DIR}/src/bson/bson-keys.c
   ${SOURCE_DIR}/src/bson/bson-md5.c
   ${SOURCE_DIR}/src/bson/bson-memory.c
   ${SOURCE_DIR}/src/bson/bson-oid.c
   ${SOURCE_DIR}/src/bson/bson-reader.c
   ${SOURCE_DIR}/src/bson/bson-string.c
   ${SOURCE_DIR}/src/bson/bson-timegm.c
   ${SOURCE_DIR}/src/bson/bson-utf8.c
   ${SOURCE_DIR}/src/bson/bson-value.c
   ${SOURCE_DIR}/src/bson/bson-version-functions.c
   ${SOURCE_DIR}/src/bson/bson-writer.c
   ${SOURCE_DIR}/src/yajl/yajl_alloc.c
   ${SOURCE_DIR}/src/yajl/yajl_buf.c
   ${SOURCE_DIR}/src/yajl/yajl.c
   ${SOURCE_DIR}/src/yajl/yajl_encode.c
   ${SOURCE_DIR}/src/yajl/yajl_gen.c
   ${SOURCE_DIR}/src/yajl/yajl_lex.c
   ${SOURCE_DIR}/src/yajl/yajl_parser.c
   ${SOURCE_DIR}/src/yajl/yajl_tree.c
   ${SOURCE_DIR}/src/yajl/yajl_version.c
)

set (HEADERS
   ${PROJECT_BINARY_DIR}/src/bson/bson-config.h
   ${PROJECT_BINARY_DIR}/src/bson/bson-stdint.h
   ${PROJECT_BINARY_DIR}/src/bson/bson-version.h
   ${SOURCE_DIR}/src/bson/bcon.h
   ${SOURCE_DIR}/src/bson/bson-atomic.h
   ${SOURCE_DIR}/src/bson/bson-clock.h
   ${SOURCE_DIR}/src/bson/bson-compat.h
   ${SOURCE_DIR}/src/bson/bson-context.h
   ${SOURCE_DIR}/src/bson/bson-endian.h
   ${SOURCE_DIR}/src/bson/bson-error.h
   ${SOURCE_DIR}/src/bson/bson.h
   ${SOURCE_DIR}/src/bson/bson-iter.h
   ${SOURCE_DIR}/src/bson/bson-json.h
   ${SOURCE_DIR}/src/bson/bson-keys.h
   ${SOURCE_DIR}/src/bson/bson-macros.h
   ${SOURCE_DIR}/src/bson/bson-md5.h
   ${SOURCE_DIR}/src/bson/bson-memory.h
   ${SOURCE_DIR}/src/bson/bson-oid.h
   ${SOURCE_DIR}/src/bson/bson-reader.h
   ${SOURCE_DIR}/src/bson/bson-stdint-win32.h
   ${SOURCE_DIR}/src/bson/bson-string.h
   ${SOURCE_DIR}/src/bson/bson-types.h
   ${SOURCE_DIR}/src/bson/bson-utf8.h
   ${SOURCE_DIR}/src/bson/bson-value.h
   ${SOURCE_DIR}/src/bson/bson-version-functions.h
   ${SOURCE_DIR}/src/bson/bson-writer.h
)

if (MSVC)
   set(BSON_SHARED_SOURCES ${SOURCES} ${PROJECT_SOURCE_DIR}/build/cmake/libbson.def)
else()
   set(BSON_SHARED_SOURCES ${SOURCES})
endif()

add_library(bson_shared SHARED ${BSON_SHARED_SOURCES} ${HEADERS})
add_library(bson_static STATIC ${SOURCES} ${HEADERS})

set_target_properties(bson_shared PROPERTIES COMPILE_DEFINITIONS "BSON_COMPILATION")
set_target_properties(bson_static PROPERTIES COMPILE_DEFINITIONS "BSON_COMPILATION")

set_target_properties(bson_shared PROPERTIES VERSION ${BSON_VERSION} SOVERSION ${BSON_MAJOR_VERSION})
set_target_properties(bson_static PROPERTIES VERSION ${BSON_VERSION} SOVERSION ${BSON_MAJOR_VERSION})

set_target_properties(bson_shared PROPERTIES OUTPUT_NAME "bson-${BSON_API_VERSION}" PREFIX "lib")
set_target_properties(bson_static PROPERTIES OUTPUT_NAME "bson-static-${BSON_API_VERSION}")

if (RT_LIBRARY)
    target_link_libraries (bson_shared ${RT_LIBRARY})
    target_link_libraries (bson_static ${RT_LIBRARY})
endif()

if (UNIX)
    target_link_libraries (bson_shared ${CMAKE_THREAD_LIBS_INIT})
    target_link_libraries (bson_static ${CMAKE_THREAD_LIBS_INIT})
else()
    target_link_libraries (bson_shared ws2_32)
    target_link_libraries (bson_static ws2_32)
endif()

if (ENABLE_TESTS)
    enable_testing()

    add_executable(test-libbson
       ${SOURCE_DIR}/tests/TestSuite.c
       ${SOURCE_DIR}/tests/TestSuite.h
       ${SOURCE_DIR}/tests/test-libbson.c
       ${SOURCE_DIR}/tests/test-atomic.c
       ${SOURCE_DIR}/tests/test-bson.c
       ${SOURCE_DIR}/tests/test-endian.c
       ${SOURCE_DIR}/tests/test-clock.c
       ${SOURCE_DIR}/tests/test-error.c
       ${SOURCE_DIR}/tests/test-iso8601.c
       ${SOURCE_DIR}/tests/test-iter.c
       ${SOURCE_DIR}/tests/test-json.c
       ${SOURCE_DIR}/tests/test-oid.c
       ${SOURCE_DIR}/tests/test-reader.c
       ${SOURCE_DIR}/tests/test-string.c
       ${SOURCE_DIR}/tests/test-utf8.c
       ${SOURCE_DIR}/tests/test-value.c
       ${SOURCE_DIR}/tests/test-version.c
       ${SOURCE_DIR}/tests/test-writer.c
       ${SOURCE_DIR}/tests/test-bcon-basic.c
       ${SOURCE_DIR}/tests/test-bcon-extract.c
    )

    target_link_libraries(test-libbson bson_static)
    add_test(NAME test-libbson COMMAND test-libbson)

    file(COPY ${SOURCE_DIR}/tests/binary ${SOURCE_DIR}/tests/json
         DESTINATION ${PROJECT_BINARY_DIR}/tests)
endif ()  # ENABLE_TESTS

install(
  TARGETS bson_shared bson_static
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
)
install(
  FILES ${HEADERS}
  DESTINATION "include/libbson-${BSON_API_VERSION}"
)

set(VERSION "${BSON_VERSION}")
set(prefix "${CMAKE_INSTALL_PREFIX}")
set(libdir "\${prefix}/lib")
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/libbson-1.0.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libbson-1.0.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/libbson-1.0.pc
    DESTINATION lib/pkgconfig
)

=== debian/changelog ===
libbson (1.3.1-1) experimental; urgency=low

  * New upstream release
  * Add symbols file for stable ABI, thanks to Ondřej Surý

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 19 Jan 2016 19:29:33 +0000

libbson (1.2.1-1) experimental; urgency=low

  * Initial release (Closes: #798695)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 16 Oct 2015 14:52:26 -0400

=== debian/control ===
Source: libbson
Priority: optional
Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
Build-Depends: debhelper (>= 9), dh-autoreconf, yelp-tools, yelp-xsl, libyajl-dev
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/mongodb/libbson
Vcs-Git: https://github.com/mongodb/libbson.git
Vcs-Browser: https://github.com/mongodb/libbson/tree/debian

Package: libbson-dev
Section: libdevel
Architecture: any
Depends: libbson-1.0-0 (= ${binary:Version}), ${misc:Depends}
Description: Library to parse and generate BSON documents - dev files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains all files necessary to develop applications which
 use libbson.

Package: libbson-1.0-0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to parse and generate BSON documents - runtime files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the libbson runtime libraries, for applications that
 have been built with libbson.

Package: libbson-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libbson-1.0-0 (= ${binary:Version}), ${misc:Depends}
Description: Library to parse and generate BSON documents - debug symbols
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the debugging symbols for libbson.

Package: libbson-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Library to parse and generate BSON documents - documentation
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the man pages for libbson.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

# main packaging script based on dh7 syntax
%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
	--prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-debug-symbols=yes --enable-html-docs=yes --enable-man-pages=yes --enable-maintainer-flags=yes 
	# Upstream's autogen.sh creates this symlink, but dh-autoreconf doesn't
	[ -f README ] || /bin/cp README.md README

override_dh_auto_build:
	dh_auto_build
	make html

override_dh_auto_clean:
	dh_auto_clean
	[ ! -f README ] || /bin/rm -f README

override_dh_strip:
	dh_strip -a --dbg-package=libbson-dbg

## libbson 1.3.5

=== debian/changelog ===
libbson (1.3.5-1) unstable; urgency=low

  [ A. Jesse Jiryu Davis ]
  * New upstream release.
  * Fix man-pages install command.
  * Remove obsolete copyrights entry.
  * Updated to Standards-Version 3.9.8 (no changes)

  [ Ondřej Surý ]
  * Remove -dbg package and add a simple BC compatible dbgsym support

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 17 May 2016 12:12:28 -0400

=== debian/rules ===
--- 
+++ 
@@ -30,12 +30,11 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	make html
+	make man html
 
 override_dh_auto_clean:
 	dh_auto_clean
 	[ ! -f README ] || /bin/rm -f README
 
 override_dh_strip:
-	dh_strip -a --dbg-package=libbson-dbg
-
+	dh_strip --dbgsym-migration='libbson-dbg (<< 1.3.1-2~)' || dh_strip

## libbson 1.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,9 @@
 project (libbson)
 
 option(ENABLE_TESTS "Build libbson tests." ON)
+option(ENABLE_EXPERIMENTAL_FEATURES
+       "Experimental support for future BSON features."
+       OFF)
 
 include(CheckFunctionExists)
 include(CheckIncludeFile)
@@ -31,12 +34,18 @@
 set (CPACK_PACKAGE_VERSION_MAJOR ${BSON_MAJOR_VERSION})
 set (CPACK_PACKAGE_VERSION_MINOR ${BSON_MINOR_VERSION})
 
+if (ENABLE_EXPERIMENTAL_FEATURES)
+   set (BSON_EXPERIMENTAL_FEATURES 1)
+else ()
+   set (BSON_EXPERIMENTAL_FEATURES 0)
+endif ()
+
 include (CPack)
-
 TEST_BIG_ENDIAN(BSON_BIG_ENDIAN)
 
 # These need proper checks like automake.
 set (BSON_PTHREAD_ONCE_INIT_NEEDS_BRACES 0)
+set (BSON_HAVE_DECIMAL128 0)
 
 #librt needed on linux for clock_gettime
 find_library(RT_LIBRARY rt)
@@ -56,6 +65,11 @@
 CHECK_FUNCTION_EXISTS(_set_output_format BSON_NEEDS_SET_OUTPUT_FORMAT)
 if (NOT BSON_NEEDS_SET_OUTPUT_FORMAT)
   set(BSON_NEEDS_SET_OUTPUT_FORMAT 0)
+endif ()
+
+CHECK_FUNCTION_EXISTS(reallocf BSON_HAVE_REALLOCF)
+if (NOT BSON_HAVE_REALLOCF)
+  set(BSON_HAVE_REALLOCF 0)
 endif ()
 
 CHECK_STRUCT_HAS_MEMBER("struct timespec" tv_sec time.h BSON_HAVE_TIMESPEC)
@@ -73,6 +87,7 @@
    set (BSON_HAVE_STDBOOL_H 0)
    set (BSON_HAVE_STRNLEN 0)
    set (BSON_EXTRA_ALIGN 1)
+   set (BSON_HAVE_SYSCALL_TID 0)
 else ()
    find_package (Threads)
 
@@ -90,6 +105,8 @@
       set(BSON_HAVE_STDBOOL_H 0)
    endif ()
    set (BSON_EXTRA_ALIGN 1)
+   CHECK_FUNCTION_EXISTS(syscall BSON_HAVE_SYSCALL_TID)
+   CHECK_INCLUDE_FILE(strings.h HAVE_STRINGS_H)
 endif ()
 
 set (BSON_HAVE_ATOMIC_32_ADD_AND_FETCH 1)
@@ -156,6 +173,10 @@
    ${SOURCE_DIR}/src/yajl/yajl_version.c
 )
 
+if (ENABLE_EXPERIMENTAL_FEATURES)
+    set (SOURCES ${SOURCES} ${SOURCE_DIR}/src/bson/bson-decimal128.c)
+endif ()
+
 set (HEADERS
    ${PROJECT_BINARY_DIR}/src/bson/bson-config.h
    ${PROJECT_BINARY_DIR}/src/bson/bson-stdint.h
@@ -185,8 +206,21 @@
    ${SOURCE_DIR}/src/bson/bson-writer.h
 )
 
+if (ENABLE_EXPERIMENTAL_FEATURES)
+    set (HEADERS ${HEADERS} ${SOURCE_DIR}/src/bson/bson-decimal128.h)
+endif ()
+
 if (MSVC)
-   set(BSON_SHARED_SOURCES ${SOURCES} ${PROJECT_SOURCE_DIR}/build/cmake/libbson.def)
+   # Export the functions listed in a definitions file.
+   if (ENABLE_EXPERIMENTAL_FEATURES)
+      set (BSON_DEF_FILE
+           ${PROJECT_SOURCE_DIR}/build/cmake/libbson-experimental.def)
+   else ()
+       set (BSON_DEF_FILE
+            ${PROJECT_SOURCE_DIR}/build/cmake/libbson.def)
+   endif ()
+
+   set(BSON_SHARED_SOURCES ${SOURCES} ${BSON_DEF_FILE})
 else()
    set(BSON_SHARED_SOURCES ${SOURCES})
 endif()
@@ -219,28 +253,51 @@
 if (ENABLE_TESTS)
     enable_testing()
 
-    add_executable(test-libbson
-       ${SOURCE_DIR}/tests/TestSuite.c
-       ${SOURCE_DIR}/tests/TestSuite.h
-       ${SOURCE_DIR}/tests/test-libbson.c
-       ${SOURCE_DIR}/tests/test-atomic.c
-       ${SOURCE_DIR}/tests/test-bson.c
-       ${SOURCE_DIR}/tests/test-endian.c
-       ${SOURCE_DIR}/tests/test-clock.c
-       ${SOURCE_DIR}/tests/test-error.c
-       ${SOURCE_DIR}/tests/test-iso8601.c
-       ${SOURCE_DIR}/tests/test-iter.c
-       ${SOURCE_DIR}/tests/test-json.c
-       ${SOURCE_DIR}/tests/test-oid.c
-       ${SOURCE_DIR}/tests/test-reader.c
-       ${SOURCE_DIR}/tests/test-string.c
-       ${SOURCE_DIR}/tests/test-utf8.c
-       ${SOURCE_DIR}/tests/test-value.c
-       ${SOURCE_DIR}/tests/test-version.c
-       ${SOURCE_DIR}/tests/test-writer.c
-       ${SOURCE_DIR}/tests/test-bcon-basic.c
-       ${SOURCE_DIR}/tests/test-bcon-extract.c
+    add_definitions("-DBINARY_DIR=\"${SOURCE_DIR}/tests/binary\"")
+    add_definitions("-DJSON_DIR=\"${SOURCE_DIR}/tests/json\"")
+
+    set (BSON_TEST_SOURCES
+         ${SOURCE_DIR}/tests/TestSuite.c
+         ${SOURCE_DIR}/tests/TestSuite.h
+         ${SOURCE_DIR}/tests/test-libbson.c
+         ${SOURCE_DIR}/tests/test-atomic.c
+         ${SOURCE_DIR}/tests/test-bson.c
+         ${SOURCE_DIR}/tests/test-endian.c
+         ${SOURCE_DIR}/tests/test-clock.c
+         ${SOURCE_DIR}/tests/test-error.c
+         ${SOURCE_DIR}/tests/test-iso8601.c
+         ${SOURCE_DIR}/tests/test-iter.c
+         ${SOURCE_DIR}/tests/test-json.c
+         ${SOURCE_DIR}/tests/test-oid.c
+         ${SOURCE_DIR}/tests/test-reader.c
+         ${SOURCE_DIR}/tests/test-string.c
+         ${SOURCE_DIR}/tests/test-utf8.c
+         ${SOURCE_DIR}/tests/test-value.c
+         ${SOURCE_DIR}/tests/test-version.c
+         ${SOURCE_DIR}/tests/test-writer.c
+         ${SOURCE_DIR}/tests/test-bcon-basic.c
+         ${SOURCE_DIR}/tests/test-bcon-extract.c
+         ${SOURCE_DIR}/tests/json-test.c
+         ${SOURCE_DIR}/tests/json-test.c
+         ${SOURCE_DIR}/tests/json-test.h
     )
+
+    if (ENABLE_EXPERIMENTAL_FEATURES)
+        set (BSON_TEST_SOURCES
+             ${BSON_TEST_SOURCES}
+             ${SOURCE_DIR}/tests/test-decimal128.c
+             ${SOURCE_DIR}/tests/test-type.c
+             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-1.json
+             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-2.json
+             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-3.json
+             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-4.json
+             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-5.json
+             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-6.json
+             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-7.json
+        )
+    endif ()
+
+    add_executable (test-libbson ${BSON_TEST_SOURCES})
 
     target_link_libraries(test-libbson bson_static)
     add_test(NAME test-libbson COMMAND test-libbson)

=== debian/changelog ===
libbson (1.4.2-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Wed, 12 Oct 2016 15:02:08 +0000

libbson (1.4.1-1) unstable; urgency=medium

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 02 Sep 2016 18:42:36 +0000

=== debian/control ===
Source: libbson
Priority: optional
Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libyajl-dev,
               yelp-tools,
               yelp-xsl
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/mongodb/libbson
Vcs-Git: https://github.com/mongodb/libbson.git
Vcs-Browser: https://github.com/mongodb/libbson/tree/debian

Package: libbson-dev
Section: libdevel
Architecture: any
Depends: libbson-1.0-0 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to parse and generate BSON documents - dev files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains all files necessary to develop applications which
 use libbson.

Package: libbson-1.0-0
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to parse and generate BSON documents - runtime files
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the libbson runtime libraries, for applications that
 have been built with libbson.

Package: libbson-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Library to parse and generate BSON documents - documentation
 libbson parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongoc, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the man pages for libbson.

=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,7 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	make man html
+	make man doc/html
 
 override_dh_auto_clean:
 	dh_auto_clean

## libbson 1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,6 @@
 project (libbson)
 
 option(ENABLE_TESTS "Build libbson tests." ON)
-option(ENABLE_EXPERIMENTAL_FEATURES
-       "Experimental support for future BSON features."
-       OFF)
 
 include(CheckFunctionExists)
 include(CheckIncludeFile)
@@ -34,18 +31,11 @@
 set (CPACK_PACKAGE_VERSION_MAJOR ${BSON_MAJOR_VERSION})
 set (CPACK_PACKAGE_VERSION_MINOR ${BSON_MINOR_VERSION})
 
-if (ENABLE_EXPERIMENTAL_FEATURES)
-   set (BSON_EXPERIMENTAL_FEATURES 1)
-else ()
-   set (BSON_EXPERIMENTAL_FEATURES 0)
-endif ()
-
 include (CPack)
 TEST_BIG_ENDIAN(BSON_BIG_ENDIAN)
 
 # These need proper checks like automake.
 set (BSON_PTHREAD_ONCE_INIT_NEEDS_BRACES 0)
-set (BSON_HAVE_DECIMAL128 0)
 
 #librt needed on linux for clock_gettime
 find_library(RT_LIBRARY rt)
@@ -147,6 +137,7 @@
    ${SOURCE_DIR}/src/bson/bson-atomic.c
    ${SOURCE_DIR}/src/bson/bson-clock.c
    ${SOURCE_DIR}/src/bson/bson-context.c
+   ${SOURCE_DIR}/src/bson/bson-decimal128.c
    ${SOURCE_DIR}/src/bson/bson-error.c
    ${SOURCE_DIR}/src/bson/bson-iso8601.c
    ${SOURCE_DIR}/src/bson/bson-iter.c
@@ -173,10 +164,6 @@
    ${SOURCE_DIR}/src/yajl/yajl_version.c
 )
 
-if (ENABLE_EXPERIMENTAL_FEATURES)
-    set (SOURCES ${SOURCES} ${SOURCE_DIR}/src/bson/bson-decimal128.c)
-endif ()
-
 set (HEADERS
    ${PROJECT_BINARY_DIR}/src/bson/bson-config.h
    ${PROJECT_BINARY_DIR}/src/bson/bson-stdint.h
@@ -186,6 +173,7 @@
    ${SOURCE_DIR}/src/bson/bson-clock.h
    ${SOURCE_DIR}/src/bson/bson-compat.h
    ${SOURCE_DIR}/src/bson/bson-context.h
+   ${SOURCE_DIR}/src/bson/bson-decimal128.h
    ${SOURCE_DIR}/src/bson/bson-endian.h
    ${SOURCE_DIR}/src/bson/bson-error.h
    ${SOURCE_DIR}/src/bson/bson.h
@@ -206,27 +194,11 @@
    ${SOURCE_DIR}/src/bson/bson-writer.h
 )
 
-if (ENABLE_EXPERIMENTAL_FEATURES)
-    set (HEADERS ${HEADERS} ${SOURCE_DIR}/src/bson/bson-decimal128.h)
-endif ()
-
-if (MSVC)
-   # Export the functions listed in a definitions file.
-   if (ENABLE_EXPERIMENTAL_FEATURES)
-      set (BSON_DEF_FILE
-           ${PROJECT_SOURCE_DIR}/build/cmake/libbson-experimental.def)
-   else ()
-       set (BSON_DEF_FILE
-            ${PROJECT_SOURCE_DIR}/build/cmake/libbson.def)
-   endif ()
-
-   set(BSON_SHARED_SOURCES ${SOURCES} ${BSON_DEF_FILE})
-else()
-   set(BSON_SHARED_SOURCES ${SOURCES})
-endif()
-
-add_library(bson_shared SHARED ${BSON_SHARED_SOURCES} ${HEADERS})
+add_library(bson_shared SHARED ${SOURCES} ${HEADERS})
 add_library(bson_static STATIC ${SOURCES} ${HEADERS})
+
+set(CMAKE_CXX_VISIBILITY_PRESET hidden)
+
 
 set_target_properties(bson_shared PROPERTIES COMPILE_DEFINITIONS "BSON_COMPILATION")
 set_target_properties(bson_static PROPERTIES COMPILE_DEFINITIONS "BSON_COMPILATION")
@@ -259,11 +231,19 @@
     set (BSON_TEST_SOURCES
          ${SOURCE_DIR}/tests/TestSuite.c
          ${SOURCE_DIR}/tests/TestSuite.h
+         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-1.json
+         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-2.json
+         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-3.json
+         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-4.json
+         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-5.json
+         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-6.json
+         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-7.json
          ${SOURCE_DIR}/tests/test-libbson.c
          ${SOURCE_DIR}/tests/test-atomic.c
          ${SOURCE_DIR}/tests/test-bson.c
          ${SOURCE_DIR}/tests/test-endian.c
          ${SOURCE_DIR}/tests/test-clock.c
+         ${SOURCE_DIR}/tests/test-decimal128.c
          ${SOURCE_DIR}/tests/test-error.c
          ${SOURCE_DIR}/tests/test-iso8601.c
          ${SOURCE_DIR}/tests/test-iter.c
@@ -271,6 +251,7 @@
          ${SOURCE_DIR}/tests/test-oid.c
          ${SOURCE_DIR}/tests/test-reader.c
          ${SOURCE_DIR}/tests/test-string.c
+         ${SOURCE_DIR}/tests/test-type.c
          ${SOURCE_DIR}/tests/test-utf8.c
          ${SOURCE_DIR}/tests/test-value.c
          ${SOURCE_DIR}/tests/test-version.c
@@ -282,24 +263,9 @@
          ${SOURCE_DIR}/tests/json-test.h
     )
 
-    if (ENABLE_EXPERIMENTAL_FEATURES)
-        set (BSON_TEST_SOURCES
-             ${BSON_TEST_SOURCES}
-             ${SOURCE_DIR}/tests/test-decimal128.c
-             ${SOURCE_DIR}/tests/test-type.c
-             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-1.json
-             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-2.json
-             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-3.json
-             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-4.json
-             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-5.json
-             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-6.json
-             ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-7.json
-        )
-    endif ()
-
     add_executable (test-libbson ${BSON_TEST_SOURCES})
 
-    target_link_libraries(test-libbson bson_static)
+    target_link_libraries(test-libbson bson_shared bson_static)
     add_test(NAME test-libbson COMMAND test-libbson)
 
     file(COPY ${SOURCE_DIR}/tests/binary ${SOURCE_DIR}/tests/json

## libbson 1.5.4

=== debian/changelog ===
libbson (1.5.4-1ubuntu2) zesty; urgency=medium

  * Really turn off the testsuite for now on all archs as they segfault. 

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 19 Feb 2017 10:48:24 +0530

libbson (1.5.4-1ubuntu1) zesty; urgency=medium

  * Turn off the test suite on arm* archs for now as they segfault. 

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 19 Feb 2017 09:55:36 +0530

libbson (1.5.4-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Mon, 30 Jan 2017 16:39:59 +0000

libbson (1.5.3-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Thu, 12 Jan 2017 16:50:07 +0000

libbson (1.5.0-1) unstable; urgency=low

  * New upstream release
  * Refresh use_system_yajl.patch for libbson 1.5.0
  * Remove symbols file

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 29 Nov 2016 03:57:33 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: libbson
 Priority: optional
-Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
                libyajl-dev,

=== debian/rules ===
--- 
+++ 
@@ -16,8 +16,6 @@
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-export DPKG_GENSYMBOLS_CHECK_LEVEL=4
-
 # main packaging script based on dh7 syntax
 %:
 	dh $@ --with autoreconf
@@ -32,6 +30,8 @@
 	dh_auto_build
 	make man doc/html
 
+override_dh_auto_test:
+
 override_dh_auto_clean:
 	dh_auto_clean
 	[ ! -f README ] || /bin/rm -f README

## libbson 1.8.0

=== debian/changelog ===
libbson (1.8.0-1) unstable; urgency=low

  * New upstream release (Closes: #874754)
  * Include cmake config files (Closes: #876194)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Thu, 14 Sep 2017 19:45:21 +0000

libbson (1.7.0-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 11 Aug 2017 02:34:43 +0000

libbson (1.6.3-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 23 May 2017 20:45:01 +0000

libbson (1.6.1-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 07 Mar 2017 20:47:35 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,9 @@
 Source: libbson
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
+Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
-               libyajl-dev,
-               yelp-tools,
-               yelp-xsl
+               python3-sphinx
 Standards-Version: 3.9.8
 Section: libs
 Homepage: https://github.com/mongodb/libbson

## libbson 1.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,35 @@
-cmake_minimum_required(VERSION 2.8)
-
-project (libbson)
-
+cmake_minimum_required(VERSION 3.1)
+
+set (MESSAGES_ENABLED 1)
+
+function(message)
+   list (GET ARGV 0 MessageType)
+   if (MESSAGES_ENABLED)
+      list (REMOVE_AT ARGV 0)
+      _message (${MessageType} "${ARGV}")
+   endif()
+endfunction()
+
+project (libbson C)
+
+set(ENABLE_STATIC AUTO CACHE STRING "Build static libbson. Set to ON/AUTO/OFF, default AUTO.")
 option(ENABLE_TESTS "Build libbson tests." ON)
+option(ENABLE_EXAMPLES "Build libbson examples." OFF)
+option(ENABLE_MAINTAINER_FLAGS "Use strict compiler checks" OFF)
+
+if (ENABLE_STATIC STREQUAL ON OR ENABLE_STATIC STREQUAL AUTO)
+   # In the future we may need to check whether static dependencies are
+   # available. For now, AUTO means ON.
+   set (BSON_ENABLE_STATIC ON)
+endif ()
+
+if (ENABLE_TESTS AND NOT BSON_ENABLE_STATIC)
+   message (FATAL_ERROR "-DENABLE_STATIC=OFF also requires -DENABLE_TESTS=OFF")
+endif ()
+
+if (NOT WIN32)
+    message(WARNING "CMake support is experimental and may not produce production quality artifacts")
+endif ()
 
 include(CheckFunctionExists)
 include(CheckIncludeFile)
@@ -42,6 +69,7 @@
 if (RT_LIBRARY)
    #set required libraries for CHECK_FUNCTION_EXISTS
    set(CMAKE_REQUIRED_LIBRARIES ${RT_LIBRARY})
+   set(BSON_LIBS ${BSON_LIBS} ${RT_LIBRARY})
 endif()
 
 # See https://public.kitware.com/Bug/view.php?id=15659
@@ -52,11 +80,6 @@
   set(BSON_HAVE_SNPRINTF 1)
 endif ()
 
-CHECK_FUNCTION_EXISTS(_set_output_format BSON_NEEDS_SET_OUTPUT_FORMAT)
-if (NOT BSON_NEEDS_SET_OUTPUT_FORMAT)
-  set(BSON_NEEDS_SET_OUTPUT_FORMAT 0)
-endif ()
-
 CHECK_FUNCTION_EXISTS(reallocf BSON_HAVE_REALLOCF)
 if (NOT BSON_HAVE_REALLOCF)
   set(BSON_HAVE_REALLOCF 0)
@@ -71,17 +94,33 @@
   set(BSON_HAVE_TIMESPEC 1)
 endif ()
 
+CHECK_SYMBOL_EXISTS(gmtime_r time.h BSON_HAVE_GMTIME_R)
+if (NOT BSON_HAVE_GMTIME_R)
+   set(BSON_HAVE_GMTIME_R 0)
+else ()
+   set(BSON_HAVE_GMTIME_R 1)
+endif ()
+
+CHECK_FUNCTION_EXISTS(rand_r BSON_HAVE_RAND_R)
+if (NOT BSON_HAVE_RAND_R)
+  set(BSON_HAVE_RAND_R 0)
+else ()
+  set(BSON_HAVE_RAND_R 1)
+endif ()
+
+if (WIN32)
+   set (BSON_OS 2)
+else ()
+   set (BSON_OS 1)
+endif ()
+
 if (MSVC)
-   set (BSON_OS 2)
    set (BSON_HAVE_CLOCK_GETTIME 0)
    set (BSON_HAVE_STDBOOL_H 0)
    set (BSON_HAVE_STRNLEN 0)
    set (BSON_EXTRA_ALIGN 1)
    set (BSON_HAVE_SYSCALL_TID 0)
 else ()
-   find_package (Threads)
-
-   set (BSON_OS 1)
    CHECK_FUNCTION_EXISTS(clock_gettime BSON_HAVE_CLOCK_GETTIME)
    if (NOT BSON_HAVE_CLOCK_GETTIME)
       set(BSON_HAVE_CLOCK_GETTIME 0)
@@ -95,7 +134,10 @@
       set(BSON_HAVE_STDBOOL_H 0)
    endif ()
    set (BSON_EXTRA_ALIGN 1)
-   CHECK_FUNCTION_EXISTS(syscall BSON_HAVE_SYSCALL_TID)
+   CHECK_SYMBOL_EXISTS(SYS_gettid sys/syscall.h BSON_HAVE_SYSCALL_TID)
+   if (NOT BSON_HAVE_SYSCALL_TID OR APPLE OR ANDROID)
+      set (BSON_HAVE_SYSCALL_TID 0)
+   endif ()
    CHECK_INCLUDE_FILE(strings.h HAVE_STRINGS_H)
 endif ()
 
@@ -130,6 +172,8 @@
 if (APPLE)
    cmake_policy(SET CMP0042 OLD)
 endif()
+
+include (MaintainerFlags)
 
 set (SOURCES
    ${SOURCE_DIR}/src/bson/bcon.c
@@ -153,15 +197,7 @@
    ${SOURCE_DIR}/src/bson/bson-value.c
    ${SOURCE_DIR}/src/bson/bson-version-functions.c
    ${SOURCE_DIR}/src/bson/bson-writer.c
-   ${SOURCE_DIR}/src/yajl/yajl_alloc.c
-   ${SOURCE_DIR}/src/yajl/yajl_buf.c
-   ${SOURCE_DIR}/src/yajl/yajl.c
-   ${SOURCE_DIR}/src/yajl/yajl_encode.c
-   ${SOURCE_DIR}/src/yajl/yajl_gen.c
-   ${SOURCE_DIR}/src/yajl/yajl_lex.c
-   ${SOURCE_DIR}/src/yajl/yajl_parser.c
-   ${SOURCE_DIR}/src/yajl/yajl_tree.c
-   ${SOURCE_DIR}/src/yajl/yajl_version.c
+   ${SOURCE_DIR}/src/jsonsl/jsonsl.c
 )
 
 set (HEADERS
@@ -195,32 +231,56 @@
 )
 
 add_library(bson_shared SHARED ${SOURCES} ${HEADERS})
-add_library(bson_static STATIC ${SOURCES} ${HEADERS})
-
 set(CMAKE_CXX_VISIBILITY_PRESET hidden)
-
-
-set_target_properties(bson_shared PROPERTIES COMPILE_DEFINITIONS "BSON_COMPILATION")
-set_target_properties(bson_static PROPERTIES COMPILE_DEFINITIONS "BSON_COMPILATION")
-
-set_target_properties(bson_shared PROPERTIES VERSION ${BSON_VERSION} SOVERSION ${BSON_MAJOR_VERSION})
-set_target_properties(bson_static PROPERTIES VERSION ${BSON_VERSION} SOVERSION ${BSON_MAJOR_VERSION})
-
+set_target_properties(bson_shared PROPERTIES COMPILE_DEFINITIONS "BSON_COMPILATION;JSONSL_PARSE_NAN")
+# CMake wants to make different symlinks than the Autotools, see
+# https://cmake.org/pipermail/cmake/2007-September/016501.html
+# This hack sets up standard symlink, libbson-1.0.so -> libbson-1.0.0.so
+set_target_properties(bson_shared PROPERTIES VERSION 0 SOVERSION ${BSON_MAJOR_VERSION})
 set_target_properties(bson_shared PROPERTIES OUTPUT_NAME "bson-${BSON_API_VERSION}" PREFIX "lib")
-set_target_properties(bson_static PROPERTIES OUTPUT_NAME "bson-static-${BSON_API_VERSION}")
 
 if (RT_LIBRARY)
-    target_link_libraries (bson_shared ${RT_LIBRARY})
-    target_link_libraries (bson_static ${RT_LIBRARY})
-endif()
-
-if (UNIX)
-    target_link_libraries (bson_shared ${CMAKE_THREAD_LIBS_INIT})
-    target_link_libraries (bson_static ${CMAKE_THREAD_LIBS_INIT})
-else()
-    target_link_libraries (bson_shared ws2_32)
-    target_link_libraries (bson_static ws2_32)
-endif()
+   target_link_libraries (bson_shared ${RT_LIBRARY})
+endif()
+
+find_library(M_LIBRARY m)
+if (M_LIBRARY)
+   target_link_libraries (bson_shared ${M_LIBRARY})
+   set(BSON_LIBS ${BSON_LIBS} ${M_LIBRARY})
+endif()
+
+set(THREADS_PREFER_PTHREAD_FLAG 1)
+find_package (Threads REQUIRED)
+target_link_libraries(bson_shared Threads::Threads)
+if(CMAKE_USE_PTHREADS_INIT)
+   set(BSON_LIBS ${BSON_LIBS} ${CMAKE_THREAD_LIBS_INIT})
+endif()
+
+if (NOT UNIX)
+   # gethostbyname
+   target_link_libraries (bson_shared ws2_32)
+   # Can't find_library () system dependencies
+   # must be handled specially since we can't resolve them
+   set(BSON_SYSTEM_LIBS ${BSON_SYSTEM_LIBS} ws2_32)
+endif()
+
+if (BSON_ENABLE_STATIC)
+   add_library(bson_static STATIC ${SOURCES} ${HEADERS})
+   set_target_properties(bson_static PROPERTIES COMPILE_DEFINITIONS "BSON_COMPILATION;BSON_STATIC;JSONSL_PARSE_NAN")
+   set_target_properties(bson_static PROPERTIES VERSION ${BSON_VERSION})
+   set_target_properties(bson_static PROPERTIES OUTPUT_NAME "bson-static-${BSON_API_VERSION}")
+   target_link_libraries(bson_static Threads::Threads)
+   if (RT_LIBRARY)
+      target_link_libraries (bson_static ${RT_LIBRARY})
+   endif()
+   if (M_LIBRARY)
+      target_link_libraries (bson_static ${M_LIBRARY})
+   endif()
+   if (NOT UNIX)
+      # gethostbyname
+      target_link_libraries (bson_static ws2_32)
+   endif ()
+endif ()
 
 if (ENABLE_TESTS)
     enable_testing()
@@ -229,18 +289,14 @@
     add_definitions("-DJSON_DIR=\"${SOURCE_DIR}/tests/json\"")
 
     set (BSON_TEST_SOURCES
+         ${SOURCE_DIR}/tests/corpus-test.c
+         ${SOURCE_DIR}/tests/corpus-test.h
          ${SOURCE_DIR}/tests/TestSuite.c
          ${SOURCE_DIR}/tests/TestSuite.h
-         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-1.json
-         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-2.json
-         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-3.json
-         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-4.json
-         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-5.json
-         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-6.json
-         ${SOURCE_DIR}/tests/json/type/decimal128/decimal128-7.json
          ${SOURCE_DIR}/tests/test-libbson.c
          ${SOURCE_DIR}/tests/test-atomic.c
          ${SOURCE_DIR}/tests/test-bson.c
+         ${SOURCE_DIR}/tests/test-bson-corpus.c
          ${SOURCE_DIR}/tests/test-endian.c
          ${SOURCE_DIR}/tests/test-clock.c
          ${SOURCE_DIR}/tests/test-decimal128.c
@@ -251,7 +307,6 @@
          ${SOURCE_DIR}/tests/test-oid.c
          ${SOURCE_DIR}/tests/test-reader.c
          ${SOURCE_DIR}/tests/test-string.c
-         ${SOURCE_DIR}/tests/test-type.c
          ${SOURCE_DIR}/tests/test-utf8.c
          ${SOURCE_DIR}/tests/test-value.c
          ${SOURCE_DIR}/tests/test-version.c
@@ -272,26 +327,52 @@
          DESTINATION ${PROJECT_BINARY_DIR}/tests)
 endif ()  # ENABLE_TESTS
 
+function (add_example bin src)
+    set (BSON_EXAMPLE_SOURCES ${SOURCE_DIR}/${src})
+    add_executable (${bin} ${BSON_EXAMPLE_SOURCES})
+
+    # Link against the shared lib like normal apps
+    target_link_libraries(${bin} bson_shared)
+
+    set (EXAMPLES ${EXAMPLES} ${bin})
+endfunction ()
+
+if (ENABLE_EXAMPLES)
+    add_example (bcon-col-view examples/bcon-col-view.c)
+    add_example (bcon-speed examples/bcon-speed.c)
+    add_example (bson-metrics examples/bson-metrics.c)
+    # Uses getopt ()
+    #add_example (bson-streaming-reader examples/bson-streaming-reader.c)
+    add_example (bson-to-json examples/bson-to-json.c)
+    add_example (bson-validate examples/bson-validate.c)
+    add_example (json-to-bson examples/json-to-bson.c)
+endif () # ENABLE_EXAMPLES
+
+set (BSON_HEADER_INSTALL_DIR "include/libbson-${BSON_API_VERSION}")
 install(
-  TARGETS bson_shared bson_static
+  TARGETS bson_shared ${EXAMPLES}
   LIBRARY DESTINATION lib
   ARCHIVE DESTINATION lib
   RUNTIME DESTINATION bin
 )
+if (BSON_ENABLE_STATIC)
+   install(
+     TARGETS bson_static ${EXAMPLES}
+     LIBRARY DESTINATION lib
+     ARCHIVE DESTINATION lib
+     RUNTIME DESTINATION bin
+   )
+endif ()
 install(
   FILES ${HEADERS}
-  DESTINATION "include/libbson-${BSON_API_VERSION}"
-)
-
-set(VERSION "${BSON_VERSION}")
-set(prefix "${CMAKE_INSTALL_PREFIX}")
-set(libdir "\${prefix}/lib")
-configure_file(
-    ${CMAKE_CURRENT_SOURCE_DIR}/src/libbson-1.0.pc.in
-    ${CMAKE_CURRENT_BINARY_DIR}/libbson-1.0.pc
-@ONLY)
-
-install(
-    FILES ${CMAKE_CURRENT_BINARY_DIR}/libbson-1.0.pc
-    DESTINATION lib/pkgconfig
-)
+  DESTINATION ${BSON_HEADER_INSTALL_DIR}
+)
+
+set(LIBBSON_LIBS "")
+foreach(_lib ${CMAKE_C_IMPLICIT_LINK_LIBRARIES} ${BSON_LIBS})
+   if(_lib MATCHES ".*/.*" OR _lib MATCHES "^-")
+    set(LIBBSON_LIBS          "${LIBBSON_LIBS} ${_lib}")
+  else()
+    set(LIBBSON_LIBS          "${LIBBSON_LIBS} -l${_lib}")
+  endif()
+endforeach()

=== examples/cmake/find_package_static/CMakeLists.txt ===
# Copyright 2017 MongoDB Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'find_package' mechanism to locate
# and build against libbson.

cmake_minimum_required (VERSION 2.8)

if (APPLE)
   cmake_policy (SET CMP0042 OLD)
endif ()

project (hello_bson LANGUAGES C)

# NOTE: For this to work, the CMAKE_PREFIX_PATH variable must be set to point to
# the directory that was used as the argument to CMAKE_INSTALL_PREFIX when
# building libbson.
# -- sphinx-include-start --
# Specify the minimum version you require.
find_package (libbson-static-1.0 1.7 REQUIRED)

message ("--   libbson-static found version \"${BSON_STATIC_VERSION}\"")
message ("--   libbson-static include path \"${BSON_STATIC_INCLUDE_DIRS}\"")
message ("--   libbson-static libraries \"${BSON_STATIC_LIBRARIES}\"")

# The "hello_bson.c" sample program is shared among four tests.
add_executable (hello_bson ../../hello_bson.c)
target_include_directories (hello_bson PRIVATE ${BSON_STATIC_INCLUDE_DIRS})
target_link_libraries (hello_bson PRIVATE ${BSON_STATIC_LIBRARIES})
target_compile_definitions (hello_bson PRIVATE ${BSON_STATIC_DEFINITIONS})

=== debian/changelog ===
libbson (1.9.2-1) unstable; urgency=low

  * New upstream release
  * Update to Standards-Version 4.1.3 (no changes)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 12 Jan 2018 12:48:01 -0500

libbson (1.9.0-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Wed, 20 Dec 2017 20:24:49 +0000

libbson (1.8.1-1) unstable; urgency=low

  * New upstream release
  * Update to Standards-Version 4.1.1 (no changes)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Thu, 12 Oct 2017 15:55:23 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
                python3-sphinx
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Section: libs
 Homepage: https://github.com/mongodb/libbson
 Vcs-Git: https://github.com/mongodb/libbson.git

=== debian/rules ===
--- 
+++ 
@@ -24,13 +24,11 @@
 	dh_auto_configure -- \
 	--prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-debug-symbols=yes --enable-html-docs=yes --enable-man-pages=yes --enable-maintainer-flags=yes 
 	# Upstream's autogen.sh creates this symlink, but dh-autoreconf doesn't
-	[ -f README ] || /bin/cp README.md README
+	[ -f README ] || /bin/cp README.rst README
 
 override_dh_auto_build:
 	dh_auto_build
-	make man doc/html
-
-override_dh_auto_test:
+	make doc/man doc/html
 
 override_dh_auto_clean:
 	dh_auto_clean

=== debian/watch ===
version=3

https://github.com/mongodb/libbson/releases /mongodb/libbson/releases/download/\d\S*/libbson-(\d\S*)\.tar\.gz

## libbson 1.9.5

=== debian/changelog ===
libbson (1.9.5-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Mon, 30 Apr 2018 22:22:18 -0400

libbson (1.9.4-1) unstable; urgency=low

  * New upstream release
  * Update to Standards-Version 4.1.4 (no changes)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 10 Apr 2018 07:56:49 -0400

libbson (1.9.3-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 02 Mar 2018 11:31:53 -0500

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
                python3-sphinx
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Section: libs
 Homepage: https://github.com/mongodb/libbson
 Vcs-Git: https://github.com/mongodb/libbson.git
